
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java字节码修改框架ASM / iVAN</title>

    <meta name="description" content="Java字节码修改框架ASM 字节码相对Java的意义类似汇编相对C的意义,底层了解的越多越深入,程序就越神奇,一切想法皆有可能实现.学习了下字节码框架ASM,总结分享下: API概述. 一.ASM库提供了两类API接口模型来产生或者修改类字节码: (1)核心API: 基于事件,每个事件代表类的一个元素,如头事件.方法事件.字段事件等.特点是更快耗费更少的内存.(2)树型API: 基于对象树状结构,字段方法等都可以看做对象树的一部分.使用相对简单,但耗费内存. 二.API包结构大致如下: (1)事件.解析器.生产器类API在">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Java字节码修改框架ASM</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>字节码相对Java的意义类似汇编相对C的意义，底层了解的越多越深入，程序就越神奇，一切想法皆有可能实现。学习了下字节码框架ASM，总结分享下：</p>
<p>API概述。</p>
<p>一、ASM库提供了两类API接口模型来产生或者修改类字节码：</p>
<p>（1）核心API: 基于事件，每个事件代表类的一个元素，如头事件、方法事件、字段事件等。特点是更快耗费更少的内存。<br />（2）树型API: 基于对象树状结构，字段方法等都可以看做对象树的一部分。使用相对简单，但耗费内存。</p>
<p>二、API包结构大致如下：</p>
<p>（1）事件、解析器、生产器类API在包路径org.objectweb.asm及org.objectweb.asm.signature内。<br />（2）开发和调试中可以用到的一些核心API在包路径org.objectweb.asm.util内。<br />（3）基于对象树的API在org.objectweb.asm.tree内，同时包括了和事件类API互相转换的工具。<br />（4）org.objectweb.asm.tree.analysis为对象树类API提供了类分析框架。</p>
<p>核心类AP I- class</p>
<p>一、类结构<br />（1）虚拟机内部定义的类结构图：<br /><a href="http://img1.tbcdn.cn/L1/461/1/50286109ce8727a94eaa7cb4da427742acb4d9ab" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmVhc3lwZXJmLmNvbS9wYWdlcy9qYXZhL2FzbS5maWxlcy9pbWFnZTAwMS5wbmc=.jpg"></a><br />（2）类名称在虚拟机内部标示有所不同，如java.lang.String内部标示为java/lang/String<br />（3）编译后的class的字段类型如下：<br /><a href="http://img4.tbcdn.cn/L1/461/1/a433a1d2382af26f57403802d47fb6450a95b9ca" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmVhc3lwZXJmLmNvbS9wYWdlcy9qYXZhL2FzbS5maWxlcy9pbWFnZTAwMi5wbmc=.jpg"></a><br />（4）方法描述内部标识如下：<br /><a href="http://img1.tbcdn.cn/L1/461/1/2b1417198eb88d05dc2be35536761897962ae016" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmVhc3lwZXJmLmNvbS9wYWdlcy9qYXZhL2FzbS5maWxlcy9pbWFnZTAwMy5wbmc=.jpg"></a></p>
<p>二、类相关接口API:</p>
<p>（1）ClassReader可以看作事件的产生器，能够读取解析类的二进制字节数组，边解析边把类的字段或者方法等信息以事件传递给ClassVisitor的相关visitXXX方法。常见代码：</p>
<p>// ClassPrinter是ClassVisitor的实例，在内部的visitXXX方法内部定义自己的业务逻辑，如打印输出</p>
<p>ClassPrinter cp = new ClassPrinter();</p>
<p>ClassReader cr = new ClassReader("java.lang.Runnable");</p>
<p>cr.accept(cp, 0);</p>
<p>（2）ClassWriter可以看做时间的一个消费器，是ClassVisitor的一个子类实现，可以直接构建出类的二进制数组标识形式，截取下例子：</p>
<p>ClassWriter cw = new ClassWriter(0);</p>
<p>// public interface Comparable extends Mesurable {</p>
<p>cw.visit(V1_5, ACC_PUBLIC + ACC_ABSTRACT + ACC_INTERFACE,</p>
<p>"pkg/Comparable", null, "java/lang/Object",</p>
<p>new String[] { "pkg/Mesurable" });</p>
<p>// int LESS = -1;</p>
<p>cw.visitField(ACC_PUBLIC + ACC_FINAL + ACC_STATIC, "LESS", "I",</p>
<p>null, new Integer(-1)).visitEnd();</p>
<p>// int EQUAL = 0;</p>
<p>cw.visitField(ACC_PUBLIC + ACC_FINAL + ACC_STATIC, "EQUAL", "I",</p>
<p>null, new Integer(0)).visitEnd();</p>
<p>// int GREATER = 1;</p>
<p>cw.visitField(ACC_PUBLIC + ACC_FINAL + ACC_STATIC, "GREATER", "I",</p>
<p>null, new Integer(1)).visitEnd();</p>
<p>// int compareTo(Object o);</p>
<p>cw.visitMethod(ACC_PUBLIC + ACC_ABSTRACT, "compareTo",</p>
<p>"(Ljava/lang/Object;)I", null, null).visitEnd();</p>
<p>cw.visitEnd();</p>
<p>byte[] b = cw.toByteArray();</p>
<p>（3）ClassVisitor可以将接收到的所有监听到事件的方法调用传递给另外一个ClassVisitor，可以看做一个事件过滤器，针对ClassVisitor添加自己的业务逻辑就可以实现神奇的字节码修改：</p>
<p>// 转换前的字节码</p>
<p>byte[] b1 = ...;</p>
<p>ClassReader cr = new ClassReader(b);</p>
<p>ClassWriter cw = new ClassWriter(cr, 0);</p>
<p>// 在这里面定义你想要的业务，一切皆有可能</p>
<p>ClassVisitor cv = new ChangeVersionAdapter(cw);</p>
<p>cr.accept(cv, 0);</p>
<p>// 转换后的字节码</p>
<p>byte[] b2 = cw.toByteArray();</p>
<p>（4）ClassVisitor内可以实现删除类成员（如visitMethod返回null删除方法）、添加类成员（visitEnd添加visitField），ClassVisitor也可以是个调用链。</p>
<p>三、开发工具API:</p>
<p>（1）Type提供了内部类型和java类型的转换，如前面提到的String转换内部类名可以这样实现:</p>
<p>// 仅用于类或者接口，java/lang/String</p>
<p>String internalName = Type.getType(String.class).getInternalName();</p>
<p>String转换为内部描述可以这样：</p>
<p>// 转换内部描述：Ljava/lang/String;</p>
<p>String internalDesc = Type.getType(String.class).getDescriptor();</p>
<p>String intDesc = Type.INT_TYPE.getDescriptor();</p>
<p>方法参数和返回值示例：</p>
<p>// 返回Type.INT_TYPE</p>
<p>Type.getArgumentTypes("(I)V");</p>
<p>// Type.VOID_TYPE</p>
<p>Type.getReturnType("(I)V")</p>
<p>（2）TraceClassVisitor可以文本形式打印出转换后的字节码到底是什么样子的：</p>
<p>ClassWriter cw = new ClassWriter(0);</p>
<p>// printWriter会输出转换后的字节码</p>
<p>TraceClassVisitor cv = new TraceClassVisitor(cw, printWriter);</p>
<p>cv.visit(...);</p>
<p>...</p>
<p>cv.visitEnd();</p>
<p>byte b[] = cw.toByteArray();</p>
<p>（3）转换后的字节码是否格式合法可以用CheckClassAdapter校验：</p>
<p>ClassWriter cw = new ClassWriter(0);</p>
<p>TraceClassVisitor tcv = new TraceClassVisitor(cw, printWriter);</p>
<p>// 发现问题会抛出异常</p>
<p>CheckClassAdapter cv = new CheckClassAdapter(tcv);</p>
<p>cv.visit(...);</p>
<p>...</p>
<p>cv.visitEnd();</p>
<p>byte b[] = cw.toByteArray();</p>
<p>（4）如果有的类实在复杂到你很难写出字节码来生成它，ASM提供自动把复杂类打印出字节码的工具ASMifier，通过命令行方式输出，太强大了：</p>
<p>java -classpath asm.jar:asm-util.jar \</p>
<p>org.objectweb.asm.util.ASMifier \</p>
<p>java.lang.Runnable</p>
<p>核心类AP I- method</p>
<p>一、方法结构</p>
<p>（1）方法执行模型：Java代码在线程内执行，每个线程有自己响应的栈stack，每个栈由栈帧frame构成，每个frame代表一个方法调用。每个frame包括本地变量和操作栈，本地变量用序号访问，变量使用slot存储，除了long和double需要2个slot外其他变量都有一个slot存储。一个frame构成如下：<br /><a href="http://img4.tbcdn.cn/L1/461/1/1598ac56561ea937173bdbaf50b233048352af94" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmVhc3lwZXJmLmNvbS9wYWdlcy9qYXZhL2FzbS5maWxlcy9pbWFnZTAwNC5wbmc=.jpg"></a><br />（2）字节码指令由操作码和参数构成，可以分为两类：一类是将值在本地变量和操作数栈来回复制移动的，如ILOAD\LLOAD\FLOAD\DLOAD\ALOAD\ISTORE\LSTORE\FSTORE等。另一类是操作操作数栈上value的，包括一大批的指令，操作栈stack的、定义常量的、算术计算的、类型转换的、操作类、操作字段、操作方法、操作数组、跳转、返回。</p>
<p>二、方法接口API和组件</p>
<p>（1）MethodVisitor可以被ClassVisitor的visitMethod方法返回，用于方法的生成和转化。MethodVisitor的内部方法严格按照如下顺序调用：<br /><a href="http://img3.tbcdn.cn/L1/461/1/2379501879f0a244de11020525f29a2c8d688c54" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmVhc3lwZXJmLmNvbS9wYWdlcy9qYXZhL2FzbS5maWxlcy9pbWFnZTAwNS5wbmc=.jpg"></a><br />多个MethodVisitor时，每个都是一个独立的转换方法实例，因此多个MethodVisitor之间可以交替执行。类似类API，MethodVisitor使用到ClassReader和ClassWriter。ClassWriter参数不同意义不同：</p>
<p>// ASM不进行任何自动计算，需要我们自己计算栈帧、本地变量、操作数栈的大小</p>
<p>new ClassWriter(0);</p>
<p>（2）一个生产getF()方法的指令如下：</p>
<p>mv.visitCode();</p>
<p>mv.visitVarInsn(ALOAD, 0);</p>
<p>mv.visitFieldInsn(GETFIELD, "pkg/Bean", "f", "I");</p>
<p>mv.visitInsn(IRETURN);</p>
<p>mv.visitMaxs(1, 1);</p>
<p>mv.visitEnd();</p>
<p>（3）MethodVisitor和ClassVisitor通常配合使用来转换方法，可以用于删除方法指令、执行状态无关的转换、执行状态相关的转换（一般需要定义状态属性到MethodVisitor内记忆）及其他更复杂的转换。</p>
<p>三、方法开发工具API</p>
<p>（1）基本的Type、TraceClassVisitor、CheckClassAdapter、ASMifier同样适用。<br />（2）AnalyzerAdapter记录了visitFrame调用后栈帧映射的信息，必须要和ClassReader#EXPAND_FRAMES配合使用。每个visitX指令都被代理到调用链，并通过本地变量locals和栈stack模拟出队栈帧映射的影响，这样后面的visitor可以得到栈帧映射的当前状态。<br />（3）LocalVariablesSorter可以对方法内的变量自动编号，对于需要修改字节码添加变量的场景非常适用。还可以喝AnalyzerAdapter配合构造成过滤链配合使用。<br />（4）需要在方法开始和结束为止添加指令的场景适合使用AdviceAdapter，而且使用与构造方法。</p>
<p> </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-27 04:00:52</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Java字节码修改框架ASM的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPB191b.html" rel="bookmark">关于java字节码框架ASM的学习</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.什么是ASM ASM是一个java字节码操纵框架,它能被用来动态生成类或者增强既有类的功能.ASM 可以直接产生二进制 class 文件,也可以在类被加载入 Java 虚拟机之前动态改变类行为.Java class 被存储在严格格式定义的 .class文件里,这些类文件拥有足够的元数据来解析类中的所有元素:类名称.方法.属性以及 Java 字节码(指令).ASM从类文件中读入信息后,能够改变类行为,分析类信息,甚至能够根据用户要求生成新类. 使用ASM框架需要导入asm的jar包,下载链接:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze60e9b.html" rel="bookmark">使用ASM操作Java字节码，实现AOP原理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文通过一个的例子来实现:使用ASM动态生成Java字节码文件(.class) 或者 加载字节码后动态修改字节码,添加我们需要执行的代码,来模拟实现Spring AOP. 年底了,也没心情抠字了,把写demo包含的几个类代码直接贴出来吧,代码拷贝下来后可以直接使用,不会有什么其他错误. 使用 asm-5.0.3.jar demo工程的package为com.shanhy.demo.asm.hello 5个Java文件: AopClassAdapter.java 用来处理哪些方法需要进行修改 Ao			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M60aWOz.html" rel="bookmark">什么时候我们需要修改java字节码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 spring,hibernate都有用到cglib, javassist来修改java字节码但是我不是很清楚为什么要这样做?以及他们是怎么做到的是在运行时还是编译时修改的?他们怎么确保修改后的语义是正确的呢 解决方案 javassist没有用过,说说cglib在AOP中,Java原生自带的模式需要依赖于接口,但是一些实现里面,是通过继承来实现的,压根就没有接口,或者只有很底层的接口.这种场景下,就没办法通过接口的这种动态代理方式来实现动作拦截.所以只好依赖于cglib.当然,最优雅的还			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bB1APOz.html" rel="bookmark">掌握Java字节码&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java是一门设计为运行于虚拟机之上的编程语言,因此它需要一次编译,处处运行(当然也是一次编写,处处测试).因此,安装到你系统上的JVM是原生的程序,而运行在它之上的代码是平台无关的.Java字节码就是你写的源代码的中间表现形式,也就是你的代码编译后的产物.你的class文件就是字节码. 简单点说,字节码就是JVM使用的代码集,它在运行时可能会被JIT编译器编译成本地代码. 你玩过汇编语言或者机器代码吗?字节码就是类似的东西,不过业界中许多人也很少会用及它,因为基本没这个必要.然而它对于理解程序			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXwW04M.html" rel="bookmark">Java字节码（&period;class文件）格式详解（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				小介:去年在读&lt;深入解析JVM&gt;的时候写的,记得当时还想着用自己的代码解析字节码的,最后只完成了一部分.现在都不知道还有没有保留着,貌似Apache有现成的BCEL工程可以做这件事.当时也只是为了学习.这份资料主要参考&lt;深入解析JVM&gt;和&lt;Java虚拟机规范&gt;貌似是1.2版本的,整理出来的.里面包含了一些自己的理解和用实际代码的测试.有兴趣的童鞋可以研究研究.嘿嘿.要有错误也希望能为小弟指点出来,感激不尽.:) 1.总体格式 Class File format type			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn7dR2z.html" rel="bookmark">Java字节码（&period;class文件）格式详解（三）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.11 在ClassFile.method_info.field_info中同时存在的Attribute 2.11.1     Synthetic Attribute Synthetic Attribute用于指示当前类.接口.方法或字段由编译器生成,而不在源代码中存在(不包含类初始函数和实例初始函数).相同的功能还有一种方式就是在类.接口.方法或字段的访问权限中设置ACC_SYNTHETIC标记.   Synthetic Attribute由JDK1.1中引入,以支持内嵌类和接口(neste			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwW23Oz.html" rel="bookmark">通过Java字节码发现有趣的内幕之String篇（上）（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文出处: jaffa 很多时候我们在编写Java代码时,判断和猜测代码问题时主要是通过运行结果来得到答案,本博文主要是想通过Java字节码的方式来进一步求证我们已知的东西.这里没有对Java字节码知识进行介绍,如果想了解更多的Java字节码或对其感兴趣的朋友可以先阅读字节码基础:JVM字节码初探. String字面量可以通过'=='判断两个字符串是否相同,是因为大家都知道'=='是用来判断两个对象的值引用地址是否一致,两个值一样的字符串字面量定义是否指向同一个值内存地址呢?答案是肯定的. 1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bodEOgM.html" rel="bookmark">Java字节码深入解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一:Java字节代码的组织形式 类文件{ OxCAFEBABE,小版本号,大版本号,常量池大小,常量池数组,访问控制标记,当前类信息,父类信息,实现的接口个数,实现的接口信息数组,域个数,域信息数组,方法个数,方法信息数组,属性个数,属性信息数组 } 二:查看方法 --- javap命令 例子:有一个Java类Demo.java public class Demo {      private String str1;      private String str2;      private			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQwAOop.html" rel="bookmark">通过java字节码分析学习对象初始化顺序&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				复制代码 代码如下: mockery.checking(new Expectations() {            {               one(new Object()).toString();               will(returnValue(&quot;&quot;));           }       }); 下面写一个写一个简单的类演示这个例子 复制代码 代码如下: public class Test {     int i = 1;    {        int			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5ArDp.html" rel="bookmark" class="title">定制UITabBar显示样式</a>
					<div>
						定制UITabBar显示样式   思路是这样子的: 1. 初始化UITabBarController,并装载进来几个其他的ViewController 2. 获取每个控制器的UITabBarItem  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9Mx2kRz.html" rel="bookmark" class="title">代码-动态规划问题，求答案</a>
					<div>
						问题描述 动态规划问题,求答案 Description 一个国家有n个城市(n不超过1000),一名旅行家住在最西边的城市里,他希望不重不漏地将每个城市浏览一遍.他的路线将是先向东经过一些城市到达最东 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbK1OEp.html" rel="bookmark" class="title">专访爆米花：广告是视频网站盈利的不二法门</a>
					<div>
						广告 3月5日:2006年下半年,在国内视频网站越来越热的时候,风险投资商却突然冷下来,以至业内感叹进入&quot;寒冬&quot;,在这样的环境下能得到投资商认可的几家网站则显得分外醒目,爆米花便是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlyDVp.html" rel="bookmark" class="title">Flash AS：让flash支持双击的类</a>
					<div>
						之前虽然有人做过相关的类,但都觉得不怎么好用,有些支持了双击,但是判断不了单击. 我这个类使用简单,而且可以判断是单击还是双击: 类内容: 观看效果: 源文件下载:点击这里下载源文件使用方法: imp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZNPoz.html" rel="bookmark" class="title">SEO优化方向：百度是如何评判内容和外链的？</a>
					<div>
						最近朋友的一批网站又被k掉了.这就说明度过了百度的危险期(6.22,6.28),并不代表百度惩罚已结束,用户体验不好的网站,随时都有被惩罚的可能.最近众多网站被降权,观察与分析的同时,也在不断的反思; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMg7xmM.html" rel="bookmark" class="title">四条搜索引擎优化小提示让您的网站为2012做好准备</a>
					<div>
						对于很多公司涵盖所有产业来说,这最后的几个月将会非常忙碌跟快速的.制定策略,预算也要通过,分级性能和投资回报率也以评估好.每个人都在为下一年第一季度的大推动做着准备.由于搜索系统优化是一个长期的过程. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jBlNb.html" rel="bookmark" class="title">SQL优化一例</a>
					<div>
						  今天闲的 看awr,发现一条SQL 每次执行40多秒,语句如下 ? 1 SELECT a.bill_class AS pol_code , b.bill_name AS pol_name , a. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPEoGz.html" rel="bookmark" class="title">如何解决win10开机内存和cpu占用过高</a>
					<div>
						  如何解决win10开机内存和cpu占用过高 关闭Defender防护 首选右键单击开始菜单,调出&quot;运行&quot;输入框(或者使用快捷键win+r),如图: 在&quot;运行&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKZ56p.html" rel="bookmark" class="title">PS自制漂亮星光笔刷</a>
					<div>
						这篇教程教朋友们用PS制作星光笔刷,教程比较实用,也比较简单,星光笔刷由于其独特的发光效果,在很多图片中都可以使用,是一款必备的笔刷.下面的教程将先容如何快速制作一款实用的星光笔刷.大致过程:新建一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRymmxb.html" rel="bookmark" class="title">在Linux系统上安装Wine的教程</a>
					<div>
						  Wine,一个在Linux平台上非常受欢迎并且强大的开源应用,有了它,我们可以在Linux平台上完美运行Windows应用与游戏. WineHQ团队,近期宣布了一个新的开发版本Wine1.7.29 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9EN9oM.html" rel="bookmark" class="title">怎样为Word2013文档属性添加关键词</a>
					<div>
						  第1步,打开Word2010文档窗口,依次单击&quot;文件&quot;→&quot;信息&quot;按钮.在打开的&quot;信息&quot;选项卡中单击&quot;属性&quot;按钮,并在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNmDrM.html" rel="bookmark" class="title">Win7右键管理器打不开</a>
					<div>
						  具体故障现象如下图所示: 其实具体原因是由于误删除了注册表的一个键值&quot;IsShortcut&quot;造成的.另外还有部分原因可能是由于安装了一些不兼容的程序引起CompMgmtLaun ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYGvrM.html" rel="bookmark" class="title">android java-多线程Thread与Runable的区别</a>
					<div>
						问题描述 多线程Thread与Runable的区别 多线程Thread与Runable的区别,优缺点.请大神们指教一下啊 解决方案 两者完全没有可比性.Runable为线程提供了一个可以执行的函数.J ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAo93M.html" rel="bookmark" class="title">急急急急急急急-fragment 中onwindowfocuschanged 用什么方法替换</a>
					<div>
						问题描述 fragment 中onwindowfocuschanged 用什么方法替换 fragment 中onwindowfocuschanged 用什么方法替换 解决方案 Andorid类似Fra ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32dw3z.html" rel="bookmark" class="title">Jenkins部署Windows UI自动化的调度权限问题</a>
					<div>
						有兄弟团队用jenkins做任务调度,对Windows上的应用通过Sikuli测试,发现Sikuli的 App.Open 无法加载应用,问我是啥原因. 对于Jenkins和Sikuli,我都是新手,通 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9YLOVM.html" rel="bookmark" class="title">DockOne微信分享（一二四）：轻松筹监控系统实现方案</a>
					<div>
						本文讲的是DockOne微信分享(一二四):轻松筹监控系统实现方案[编者的话]监控系统是服务管理最重要的组成部分之一,可以帮助开发人员更好的了解服务的运行状况,及时发现异常情况.虽然阿里提供收费的业务 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPk8JZM.html" rel="bookmark" class="title">Facebook开放轻量开源工具Fbthrift</a>
					<div>
						据媒体消息,今天http://www.aliyun.com/zixun/aggregation/1560.html&quot;&gt;Facebook宣布开放另一个版本的软件库和代码生成工具,通过这个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAEkyKM.html" rel="bookmark" class="title">用互联网思路来做电视</a>
					<div>
						乐视.爱奇艺.小米三家中国互联网企业均在今年先后发布了互联网电视,向传统电视机厂商发起攻势.各有打法的同时,很可能像当年智能手机颠覆功能手机市场一样迅猛. 在爱奇艺的TV+电视发布后的两天,小米也发布 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJXwQp.html" rel="bookmark" class="title">数据资产管理将驱动经济的创新与变革</a>
					<div>
						伴随着大数据时代的悄然来临,对数据的重视提到了前所未有的高度.套上大数据的光环后,原本那些存放在服务器上平淡无奇的陈年旧数一夜之间身价倍增.但是,数据真的可以和资产直接划上等号吗?在获得高度重视的同时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0nLw8z.html" rel="bookmark" class="title">使用ScriptManager后无脑报错，看图</a>
					<div>
						问题描述 如图所示就是最简单的一个页面拖一个ScriptManager后都报这个错但是再次刷新页面后正常这个情况只在每次重新启动应用程序池后第一次访问页面时发生求教大神-- 解决方案 解决方案二:二进 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX017lp.html" rel="bookmark" class="title">中星微着手4G率先推出高清4G云台摄像机</a>
					<div>
						硅谷网12月20日讯 2013年12月4日,工业和信息化部 正式向 三大运营商 发布4G牌照,中国移动 .中国电信 和中国联通 均获得TD-LTE 牌照. 4G是第四代移动通信及其技术的简称,是集3G ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Rvaqz.html" rel="bookmark" class="title">seadas安装问题-这些权限不够的问题如何解决！！！</a>
					<div>
						问题描述 这些权限不够的问题如何解决!!! 解决方案 用sudo先提升权限 解决方案二: 参考SeaDAS 7.2 If you want to try running seadas without  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7Zr2z.html" rel="bookmark" class="title">数据结构-平衡二叉树的辨别方法</a>
					<div>
						问题描述 平衡二叉树的辨别方法 最近在看数据结构,关于平衡二叉树的辨别有以下一段话: 问题是:既然图3的58结点的左子树高度为2,右子树为空,那么图1也是的,但图1是平衡二叉树而图3不是,这岂不是相互 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNPK8M.html" rel="bookmark" class="title">发展&OpenCurlyDoubleQuote;车联网&rdquo;产业成都技术基础坚实</a>
					<div>
						如同阿里巴巴.腾讯.京东.华为等互联网知名企业同样选择,乐视在成都悄悄地建成了其车联特殊技术研发中心.研发的全新生态互联产品ecolink欲比肩苹果CarPlay,未来计划搭载更多汽车产品. 互联网公 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7mDjM.html" rel="bookmark" class="title">C&plus;&plus;编程小心指针被delete两次&lowbar;C 语言</a>
					<div>
						在C++类中,有时候会使用到传值调用(即使用对象实体做参数),当遇到这种情况,可要小心了!尤其是当你所传值的对象生命周期较长,而非临时对象(生命周期段)的时候.来看看下面的情况: #include & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7JBEM.html" rel="bookmark" class="title">Android获取view高度的三种方式&lowbar;Android</a>
					<div>
						本文为大家分享了Android获取view高度的方法,供大家参考,具体内容如下 getMeasuredHeight()与getHeight的区别 实际上在当屏幕可以包裹内容的时候,他们的值相等, 只有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxEa3Rp.html" rel="bookmark" class="title">jQuery点击自身以外地方关闭弹出层的简单实例&lowbar;jquery</a>
					<div>
						主要功能是点击显示,然后通过点击页面的任意位置都能关闭显示效果,主要是$(document).click的作用 开发过程中经常有一些弹出层,弹出后要在点击页面其他地方时自动关闭,下面是实现代码: HT ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1QAOb.html" rel="bookmark" class="title">影响SEO的页面制作细节&lowbar;网站应用</a>
					<div>
						jxdawei的个人博客:http://www.iwcn.net 1.将css与javascript全部用下边的方法分离到外部文件中去. &lt;link rel=&quot;stylesheet&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0wJNp.html" rel="bookmark" class="title">底层实现-外接了一块串口芯片，怎么对串口芯片做配置</a>
					<div>
						问题描述 外接了一块串口芯片,怎么对串口芯片做配置 芯片型号是16c950,芯片手册上指名有三条地址线可以用来配置芯片寄存器,但是具体该怎么配置阿?有没有人来指点一下.芯片手册上没有做说明啊 解决方案 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwyLv5M.html" rel="bookmark" class="title">科技撬动&OpenCurlyDoubleQuote;互联网银行&rdquo;金矿</a>
					<div>
						2012年9月,腾讯宣布打通旗下财付通与移动产品微信的应用通道,这意味着其2亿用户可通过微信扫描商户二维码的方式付款,并享受折扣优惠.而此前两个月,阿里巴巴宣布,旗下阿里小贷将向江浙沪地区的B2B普通 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
